"""
Name:
setup.py
  
Usage:
    See distutils for std options.
    This version adds "test" and "doc"
    

Options:
    --help             this message
    test               test the package
    doc                generate the documents
    
Examples:
    cd mydir
    (cp myfile.tar.gz here)
    gzip -cd myfile.tar.gz | tar xvf -
    cd myfile
    python setup.py build
    python setup.py test
    python setup.py install
    python setup.py doc
    python setup.py dist
"""

#===configuration=============
import os,sys,re,string,getopt,shutil,commands
from cStringIO import StringIO
from distutils.core import setup

pkgname='cgipm'
modname='setup.py'

#=============================

#--------------------
def debug(ftn,txt):
    sys.stdout.write(modname+'.'+ftn+':'+txt+'\n')
    sys.stdout.flush()
    
#--------------------
def fatal(ftn,txt):
    sys.stdout.write(string.join([modname,'.',ftn,':FATAL:',txt,'\n'],''))
    sys.stdout.flush()
    sys.exit(1)
#--------------------
def usage():
    print __doc__

#--------------------
def do_test():
    ftn="do_test"
    debug(ftn,"begin")
    os.system("cd test; go")

#----------------------
def do_doc():
    ftn="do_doc"
    debug(ftn,"begin")
    os.system("cd doc; go")

#==============================
if __name__ == '__main__':
    opts,pargs=getopt.getopt(sys.argv[1:],'hv',
                 ['help','version'])
    for opt in opts:
        if opt[0]=='-h' or opt[0]=='--help':
            usage()
            sys.exit(0)
        elif opt[0]=='-v' or opt[0]=='--version':
            print modname+": version="+version

    for arg in pargs:
        if arg=='test':
            do_test()
            sys.exit(0)
        elif arg=='doc':
            do_doc()
            sys.exit(0)
        else:
            pass

    #---disutils setup---
    setup (# Distribution meta-data
           name = "cgipm",
           version = "0.3",
           description = "cgipm",
           maintainer = "Harry George",
           maintainer_email = "hgg9140@seanet.com",
           licence = "LGPL",

           # Description of the modules and packages in the distribution
           py_modules = ['cgipm']
    ##        packages = ['']
    ##        package_dir = {'': 'Lib'},
    ##        install_path = 'cgipm',
    ##        include_dirs = ['Include'],
    ##        ext_modules = [('myext',
    ##                        { 'sources' : ['Src/myext.c']
    ##                        }
    ##                       ),
           )


