#!/usr/bin/python -t
#/* test01.py 
# * Copyright (C) 2000  anonymous
# *
# * This library is free software; you can redistribute it and/or
# * modify it under the terms of the GNU Library General Public
# * License as published by the Free Software Foundation; either
# * version 2 of the License, or (at your option) any later version.
# *
# * This library is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# * Library General Public License for more details.
# *
# * You should have received a copy of the GNU Library General Public
# * License along with this library; if not, write to the
# * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# * Boston, MA 02111-1307, USA.
# */


"""
Usage: test01.py [options] filename
E.g.,  test01.py --aa --bb=xyz myfile
Options
-h,--help        this message
-v,--version     version
-a,--aa          set boolean 'a'
-b,--bb          set option bb to xyz

Revisions:
2000-02-22  anonymous   initial version
"""

import sys,os,getopt,time,re,string,exceptions

#---prepend parent dir so we get the version under test--- 
sys.path.insert(0,os.pardir)
import cgipm

modname="test01"
__version__="0.1"

def debug(ftn,txt):
	sys.stdout.write(modname+'.'+ftn+':'+txt+'\n')
	sys.stdout.flush()

def fatal(ftn,txt):
	sys.stdout.write(modname+'.'+ftn+':FATAL:'+txt+'\n')
	sys.stdout.flush()
	sys.exit(1)

def usage():
	print __doc__

class test01(cgipm.CGI):
	#---class variables---
	#--------------------------
	def __init__(self,*args):
		ftn="test01"+".__init__"
		cgipm.CGI.__init__(self)
		#debug(ftn,"hello, world")
	#--------------------------
	def run(self):
		ftn="run"
		if self.isquery:
			self.processform()
		else:
			self.sendform()
	#--------------------------
	def sendform(q):
		def mkrow(name,val):
			return '<TR><TD>'+name+'</TD><TD>'+val+'</TD></TR>'
		print q.header()
		title='Test01'
		print q.start_html(title=title,author='John Doe')
		print q.tag('center',q.tag('big',q.tag('strong',title)))

		#---shortcuts---
		print q.hr
		print q.h1('HTML Shortcuts')
		#print q.ul(q.li('generic',q.li('tag'),q.li('start_tag','end_tag')))

		print q.ul(q.li('generic',q.ol(q.li('tag'),q.li('start_tag','end_tag')))
				   ,q.li('prebuilt',q.ol(q.li('header 1..6'),q.li('ul, ol, li'),type='a')))
		
		#---forms---
		print q.hr

		print q.h1('HTML Forms')
		#---start form---
		print q.startform(action='http://wilma/cgi-bin/hgg9140/test/test01.py',
					   method="GET")
		print q.start_tag('table','border',cellspacing=2,cellpadding=5)
		
		#---inputs---
		print mkrow("textfield",
			  q.textfield(name="mytextfield",value="hello, world",size=50,maxlength=10))
		print mkrow("password",
			  q.password(name="mypassword",value="hello, world",size=50,maxlength=10))
		print mkrow("hidden",
			  q.hidden(name="myhidden",value="hello, world"))
		print mkrow("button",
			  q.button(label="mybutton",value="a button",onscript="xyz"))
		print mkrow("submit",
			  q.submit(label="mysubmit",value="submit now",size=20))
		print mkrow("reset",
			  q.reset(label="myreset",value="reset now",size=20))

		#---textarea---
		print mkrow("textarea",
			  q.textarea(name="mytextarea",current="hello, world\ngoodbye, world",
							rows=10,cols=40))
		#---checkboxes---
		print mkrow("checkboxes",
			  q.checkbox_group(name="mycheckboxes"
								  ,values=['bird','cat','dog']
								  ,defaults=['cat']
								  ,linebreak=1
								  ,labels={'bird':'parrot','cat':'persian','dog':'pekinese'}
								  ))
		
		#---radio_group---
		print mkrow("radio_group",
			  q.radio_group(name="myradiogroup"
								  ,values=['bird','cat','dog']
								  ,default='-'
								  ,linebreak=1
								  ,labels={'bird':'parrot','cat':'persian','dog':'pekinese'}
								  ))
		#---popup_menu---
		print mkrow("popup_menu",
			  q.popup_menu(name="mypopup_menu"
								  ,values=['bird','cat','dog']
								  ,default='cat'
								  ,labels={'bird':'parrot','cat':'persian','dog':'pekinese'}
								  ))
		#---scrolling_list---
		print mkrow("scrolling_list",
			  q.scrolling_list(name="myscrolling_list"
								  ,values=['bird','cat','dog']
								  ,default='cat'
								  ,size=2
								  ,multiple=1
								  ,labels={'bird':'parrot','cat':'persian','dog':'pekinese'}
								  ))
		#---end form---
		print q.end_tag('table')
		print q.endform()	
		print q.end_html()
	#-------------------------
	def processform(q):
		ftn="processform"

		print q.header()
		title='Test01: CGI response'
		print q.start_html(title=title,author='John Doe')
		print q.tag('center',q.tag('big',q.tag('strong',title)))

		data=q.params()
		#debug(ftn,"data="+`data`)

		print q.start_tag('table','border',cellspacing=2,cellpadding=5)
		print q.tr(q.th("Key"),q.th("Value"))
		for key in data.keys():
			value=data[key]
			print q.tr(q.td(key),q.td(value))
		print q.end_tag('table')
		print q.end_html()

#---main-----------
#exemplars; tweak as needed
opt_a=0     #boolean arg, default is false
opt_b=None  #string arg, default is undefined

#positional args, default is empty
pargs=[]    

if __name__ == '__main__':
	x=test01()
	x.run()



